module KeyScan(clk, key_row, key_col, LED);
	input				clk;
	input [2:0]			key_col;
	output [7:0]		key_row;
	output [7:0]		LED;
	
	reg					clk_1khz;
	integer				cnt_1khz = 0;
	reg [4:0]			key_val;
	reg [7:0]			row_val = 8'b00000001;
	reg [2:0]			col_val;
	
	always @ (posedge clk) begin
		if (cnt_1khz >= 499) begin
			cnt_1khz = 0;
			clk_1khz = ~clk_1khz;
		end else begin
			cnt_1khz <= cnt_1khz + 1;
		end
	end
	
	always @ (posedge clk_1khz) begin
		row_val [7:1] <= row_val[6:0];
		row_val [0]   <= row_val [7];
	end
	
	assign key_row = row_val;
	
	always @ (negedge clk_1khz) begin
		if (row_val == 8'b10000000) begin
			case (key_col)
				4'b100 : key_val <= 24;
				4'b010 : key_val <= 16;
				4'b001 : key_val <= 8;
				default : key_val <= 0;
			endcase
		end else if (row_val == 8'b01000000) begin
			case (key_col)
				4'b100 : key_val <= 23;
				4'b010 : key_val <= 15;
				4'b001 : key_val <= 7;
				default : key_val <=0;
			endcase
		end else if (row_val == 8'b00100000) begin
			case (key_col)
				4'b100 : key_val <= 22;
				4'b010 : key_val <= 14;
				4'b001 : key_val <= 6;
				default : key_val <=0;
			endcase
		end else if (row_val == 8'b00010000) begin
			case (key_col)
				4'b100 : key_val <= 21;
				4'b010 : key_val <= 13;
				4'b001 : key_val <= 5;
				default : key_val <= 0;
			endcase
		end else if (row_val == 8'b00001000) begin
			case (key_col)
				4'b100 : key_val <= 20;
				4'b010 : key_val <= 12;
				4'b001 : key_val <= 4;
				default : key_val <= 0;
			endcase
		end else if (row_val == 8'b00000100) begin
			case (key_col)
				4'b100 : key_val <= 19;
				4'b010 : key_val <= 11;
				4'b001 : key_val <= 3;
				default : key_val <= 0;
			endcase
		end else if (row_val == 8'b00000010) begin
			case (key_col)
				4'b100 : key_val <= 18;
				4'b010 : key_val <= 10;
				4'b001 : key_val <= 2;
				default : key_val <= 0;
			endcase
		end else if (row_val == 8'b00000001) begin
			case (key_col)
				4'b100 : key_val <= 17;
				4'b010 : key_val <= 9;
				4'b001 : key_val <= 1;
				default : key_val <= 0;
			endcase
		end else begin
			key_val <= 0;
		end
	end
	
	assign LED [7:5] = 0;
	assign LED [4:0] = key_val;
endmodule