module DotMatrix(clk, dot_data, col_out);
	input					clk;
	output reg[6:0]	dot_data;
	output reg[3:0]	col_out;
	
	reg 					clk_1khz;
	reg					clk_1hz;
	reg					data;
	
	integer				cnt_1khz = 0;
	integer				cnt_1hz = 0;
	integer				i = 0;
	reg [3:0]			col_no;
	
//	parameter integer dot_data1 [4:0] = '{7'b1101010,
//											7'b1001101,
//											7'b1011101,
//											7'b1001101,
//											7'b1001010};

//	parameter integer dot_data2 [4:0] = '{7'b1111100,
//											7'b0101100,
//											7'b0101111,
//											7'b0101100,
//											7'b1111100};
//											
											
	parameter integer dot_data1 [4:0] = '{7'b0010101,
											7'b0110010,
											7'b0100010,
											7'b0110010,
											7'b0110101};

	parameter integer dot_data2 [4:0] = '{7'b0000011,
											7'b1010011,
											7'b1010000,
											7'b1010011,
											7'b0000011};
											
										
	assign col_out = col_no;

	always @ (posedge clk) begin
		if (cnt_1hz >= 499999) begin
			cnt_1hz = 0;
			clk_1hz = ~clk_1hz;
			data <= ~data;
		end else begin
			cnt_1hz <= cnt_1hz + 1;
		end
	end
	
	always @ (posedge clk) begin
		if (cnt_1khz >= 499) begin
			cnt_1khz = 0;
			clk_1khz = ~clk_1khz;
		end else begin
			cnt_1khz <= cnt_1khz + 1;
		end
	end
	
	always @ (posedge clk_1khz) begin
		if (col_no == 4'h4) begin
			col_no <= 4'h0;
		end else begin
			col_no <= col_no + 1'b1;
		end
	end
	
	always @ (col_no) begin
		if (data == 1'b0) begin
			case(col_no)
				4'h0 : dot_data <= dot_data1[0];
				4'h1 : dot_data <= dot_data1[1];
				4'h2 : dot_data <= dot_data1[2];
				4'h3 : dot_data <= dot_data1[3];
				4'h4 : dot_data <= dot_data1[4];
			endcase
		end else begin
			case(col_no)
				4'h0 : dot_data <= dot_data2[0];
				4'h1 : dot_data <= dot_data2[1];
				4'h2 : dot_data <= dot_data2[2];
				4'h3 : dot_data <= dot_data2[3];
				4'h4 : dot_data <= dot_data2[4];
			endcase
		end	
	end
endmodule