library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity BuzzerSound is
port( clk			:	in std_logic;
		switch		 : in std_logic;
		buzzer_out	:	out std_logic;
		buzzer_out2	:	out std_logic
		);
end BuzzerSound;

architecture design of BuzzerSound is
	signal	clk_1hz	:	std_logic;
	signal	clk_1khz	:	std_logic;
	signal	buzzer	:	std_logic;
	signal	buzzer2	:	std_logic;
begin
	process(clk)
		variable cnt_1hz	: integer range 0 to 500000;
		variable cnt_1khz	: integer range 0 to 5000;
	begin 
		if rising_edge(clk) then
			if cnt_1hz >= 499999 then
				clk_1hz <= not clk_1hz;
				cnt_1hz := 0;
			else
				cnt_1hz := cnt_1hz + 1;
			end if;
			
			if cnt_1khz >= 499 then
				clk_1khz <= not clk_1khz;
				cnt_1khz := 0;
			else
				cnt_1khz := cnt_1khz + 1;
			end if;
			
		end if;
	end process;

	process(clk_1hz, switch, buzzer)
	begin
		if (switch = '1') then
			if (clk_1hz = '0') then
				buzzer <= '0';
			else
				buzzer <= '1';
			end if;
		else
				buzzer <= '0';
		end if;
	end process;
	buzzer_out <= buzzer;

	process(clk_1hz, clk_1khz, switch)
	begin
		if (switch = '0') then
			if (clk_1hz = '0') then
				buzzer2 <= '0';
			else
				buzzer2 <= clk_1khz;
			end if;
		else
				buzzer2 <= '0';
		end if;
	end process;
	buzzer_out2 <= buzzer2;

end design;