module TextLCD (clk, D_En, RS, RW, DB, reset, backlight);
	input				clk, reset;
	output			D_En, RS, RW;
	output			backlight;
	output [7:0]	DB;
	
	reg				clk_1khz, RS, D_En;
	reg [7:0]		lcd_db;
	reg [6:0]		lcd_cnt;
	
	integer			cnt_1khz = 0;
	
	always @ (posedge clk) begin
		if (cnt_1khz >= 499) begin
			cnt_1khz <= 0;
			clk_1khz <= ~clk_1khz;
		end else begin
			cnt_1khz <= cnt_1khz + 1;
		end
	end
	
	assign backlight = 1'b1;
	assign RW = 1'b0;
	
	always @ (posedge clk_1khz or negedge reset) begin
		if (~reset) begin
			lcd_cnt <= 0;
		end else begin
			if (lcd_cnt >= 86) begin
				lcd_cnt <= 54;
			end else begin
				lcd_cnt <= lcd_cnt + 1;
			end
		end
	end
	
	always @ (*) begin
		if ( (lcd_cnt >= 0 && lcd_cnt <= 54) || (lcd_cnt == 68) ) begin
			RS <= 1'b0;
		end else begin
			RS <= 1'b1;
		end
	end
	
	always @ (*) begin
		if ((lcd_cnt >= 50) && (lcd_cnt <=84)) begin
			D_En <= clk_1khz;
		end else begin
			D_En <= 1'b0;
		end
	end
	
	always @ (lcd_cnt) begin
		case (lcd_cnt)
			// rw = '0', rs = '0'
			50 : lcd_db <= 8'b00111000;
			51 : lcd_db <= 8'b00001100;
			52 : lcd_db <= 8'b00000001;
			53 : lcd_db <= 8'b00000110;
			54 : lcd_db <= 8'b10000000;
			
			// rw = '0', rs = '1'
			55	: lcd_db <= 8'b00100000; //  blank
			56	: lcd_db <= 8'b01010111; //   W
			57	: lcd_db <= 8'b01100101; //   e	
			58	: lcd_db <= 8'b01101100; //   l	
			59	: lcd_db <= 8'b01000011; //   C	
			60	: lcd_db <= 8'b01101111; //   o	
			61	: lcd_db <= 8'b01101101; //   m	
			62	: lcd_db <= 8'b01100101; //   e	
			63	: lcd_db <= 8'b00100000; //   blank	
			64	: lcd_db <= 8'b01110100; //   t	
			65	: lcd_db <= 8'b01101111; //   o	
			66	: lcd_db <= 8'b00100000; //   blank	
			67	: lcd_db <= 8'b00100000; //   blank	
			
			// rw = '0', rs = '0'
			68 : lcd_db <= 8'b11000000;
			
			// rw = '0', rs = '1'
			69	: lcd_db <= 8'b00100000; //   blank	
			70	: lcd_db <= 8'b01000110; //   F	
			71	: lcd_db <= 8'b01010000; //   P	
			72	: lcd_db <= 8'b01000111; //   G
			73	: lcd_db <= 8'b01000001; //   A	
			74	: lcd_db <= 8'b00100000; //   blank	
			75	: lcd_db <= 8'b00100000; //   blank	
			76	: lcd_db <= 8'b01010111; //   W
			77	: lcd_db <= 8'b01101111; //   o	
			78	: lcd_db <= 8'b01110010; //   r	
			79	: lcd_db <= 8'b01101100; //   l	
			80	: lcd_db <= 8'b01100100; //   d	
			81	: lcd_db <= 8'b00100001; //   !	
			82	: lcd_db <= 8'b00100001; //   !	
			83	: lcd_db <= 8'b00100001; //   !	
			84	: lcd_db <= 8'b00100001; //   !	
			default:lcd_db <= 8'b00000000;
		endcase
	end
	
	assign DB = lcd_db;
	
endmodule
