`timescale 1ns / 1ps
module Step_Motor(clock, speed, dirIn, ms, step_en, stepOut, dir, ms_out);
parameter StepDivider = 1250; // 400Hz
//parameter StepDivider = 2500; // 200Hz
//parameter StepDivider = 5000; // 100Hz

	input	clock, dirIn;
	input	[1:0]	speed;
	input ms;
	output step_en, stepOut, dir;
	output [2:0] ms_out;
	
	reg			step_en, step, dir;
	reg			stepClk;
	integer		cnt;
	
	always @ (posedge clock)
	begin
		if (cnt >= StepDivider*(speed+1)/2) begin
				cnt <= 0;
				stepClk <= ~stepClk;
		end else
				cnt <= cnt+1;
	end			
 
	always @ (posedge stepClk) begin
			step_en <= 1'b0;
			step <= ~step;
			if (dirIn == 1) begin
				dir <= 1;
			end else begin
				dir <= 0;
			end
	end
	assign stepOut = step;
	assign ms_out[0] = ms;
	assign ms_out[1] = 1'b0;
	assign ms_out[2] = 1'b0;
endmodule