module ServoMotor(clk, sw_in, ServoOut1, ServoOut2);
	input				clk;
	input [2:0]		sw_in;
	output			ServoOut1, ServoOut2;
	
	reg				clk_500KHz;
	reg				cpulse = 1'b1;
	reg				rpulse = 1'b1;
	reg				lpulse = 1'b1;
	reg				Servo;
	
	reg [2:0]		mode;
	
	integer cnt_20ms = 0;
	integer cnt_1_5ms	= 0;
	integer cnt_0_9ms	= 0;
	integer cnt_2_1ms	= 0;
	
// switch input : sw(0) => reset, sw(1) => right turn, sw(2) => left turn

// 500KHz clock generation	
	always @ (posedge clk) begin
		clk_500KHz <= ~ clk_500KHz;
	end
			
// right direction pulse generation(2.1msec duration)
	always @ (posedge clk_500KHz) begin
		if (cnt_20ms < 10000) begin
			cnt_20ms <= cnt_20ms + 1;
			if (cnt_1_5ms < 750) begin
				cnt_1_5ms <= cnt_1_5ms + 1;
			end else begin
				cpulse <= 1'b0;
			end;
				
			if (cnt_0_9ms < 450) begin
				cnt_0_9ms <= cnt_0_9ms + 1;
			end else begin
				lpulse <= 1'b0;
			end;
			
			if (cnt_2_1ms < 1050) begin
				cnt_2_1ms <= cnt_2_1ms + 1;
			end else begin
				rpulse <= 1'b0;
			end;
		end else begin
			cnt_20ms <= 1'b0;
			cnt_1_5ms <= 1'b0;
			cnt_0_9ms <= 1'b0;
			cnt_2_1ms <= 1'b0;

			cpulse <= 1'b1;
			lpulse <= 1'b1;
			rpulse <= 1'b1;
		end;
	end
			
	always @ (posedge clk) begin
		mode <= sw_in;
		case (mode)
			3'b100 : Servo <= cpulse;
			3'b010 : Servo <= lpulse;
			3'b001 : Servo <= rpulse;
			default;
		endcase;	
	end
	assign ServoOut1 = Servo;
	assign ServoOut2 = Servo;
endmodule